(* Programming and Reasoning with Infinite Data in Isabelle/HOL (POPL 2018) *)
(* Mathias Fleury, Andreas Lochbihler, Andrei Popescu *)

theory Corec imports Prelim
begin
  
codatatype 'a stream = SCons (shd: 'a) (stl: "'a stream")
  
corec ones :: "nat stream" where 
  "ones = SCons 1 ones"
  
corec plus :: "nat stream \<Rightarrow> nat stream \<Rightarrow> nat stream" where 
  "plus xs ys = SCons (shd xs + shd ys) (plus (stl xs) (stl ys))"

corec times :: "nat stream \<Rightarrow> nat stream \<Rightarrow> nat stream" where 
  "times xs ys = SCons (shd xs * shd ys) (plus (times xs (stl ys)) (times (stl xs) ys))"

(* Error: "plus" not registered as friend *)

 


end
  
