(* Programming and Reasoning with Infinite Data in Isabelle/HOL (POPL 2018) *)
(* Mathias Fleury, Andreas Lochbihler, Andrei Popescu *)

theory Mixed_Rec_Corec
  imports Corec
begin

(* Distinguish recursive and corecursive calls: *)

corec collatz :: "nat \<Rightarrow> nat stream" where 
  "collatz n = 
   (if n \<le> 1 
      then ones 
      else if even n then collatz (n div 2)
                     else SCons n (collatz (3 * n + 1)))"  

 
(* Question: why must _recursive_ calls also be surrounded by friends? E.g., 
the folowing is accepted (after plus is registered as a friend):
*)

corec collatz' :: "nat \<Rightarrow> nat stream" where 
  "collatz' n = 
   (if n \<le> 1 
      then ones 
      else if even n then plus (collatz' (n div 2)) ones
                     else SCons n (collatz' (3 * n + 1)))"

(* But the following is not: *)

corec collatz'' :: "nat \<Rightarrow> nat stream" where 
  "collatz'' n = 
   (if n \<le> 1 
      then ones 
      else if even n then eo (collatz'' (n div 2)) 
                     else SCons n (collatz'' (3 * n + 1)))"

 
end
